<?php
/**
 * @file
 * Webform module sameas component.
 */

/**
 * Implements _webform_defaults_component().
 */
function _webform_defaults_sameas() {
  return array(
    'name' => '',
    'form_key' => NULL,
    'pid' => 0,
    'weight' => 0,
    'value' => '',
    'mandatory' => FALSE,
    'extra' => array(
      'size' => '',
      'maxlength' => '25',
      'disabled' => 0,
      'unique' => TRUE,
      'title_display' => 0,
      'description' => NULL,
      'attributes' => array(
        'class' => array(
          'webform-sameas',
        ),
      ),
      'private' => FALSE,
      'display_mode' => 'disabled',
      'src_field' => '',
      'target_field' => '',
    ),
  );
}

/**
 * Implements _webform_edit_component().
 */
function _webform_edit_sameas($component) {
  $form = array();
  $form['value'] = array(
    '#type' => 'checkbox',
    '#title' => t('Default value'),
    '#default_value' => $component['value'],
    '#description' => t('The default value of the field.'),
  );
  $form['display']['display_mode'] = array(
    '#type' => 'select',
    '#options' => array(
      'invisible' => t('Hide target fields'),
      'disabled' => t('Disable target fields'),
    ),
    '#default_value' => $component['extra']['display_mode'],
    '#parents' => array('extra', 'display_mode'),
    '#title' => t('Display mode'),
  );
  $form['mapping']['src_fields'] = array(
    '#type' => 'select',
    '#options' => _webform_sameas_get_other_components($component['nid'], $component['form_key']),
    '#parents' => array('extra', 'src_field'),
    '#default_value' => $component['extra']['src_field'],
    '#title' => t('Source Field'),
  );
  $form['mapping']['target_fields'] = array(
    '#type' => 'select',
    '#options' => _webform_sameas_get_other_components($component['nid'], $component['form_key']),
    '#parents' => array('extra', 'target_field'),
    '#default_value' => $component['extra']['target_field'],
    '#title' => t('Target Field'),
  );
  return $form;
}

/**
 * Render a Webform component to be part of a form.
 */
function _webform_render_sameas($component, $value = NULL, $filter = TRUE) {
  $element = array(
    '#type' => 'checkbox',
    '#title' => $filter ? _webform_filter_xss($component['name']) : $component['name'],
    '#title_display' => $component['extra']['title_display'] ? $component['extra']['title_display'] : 'before',
    '#default_value' => $filter ? _webform_filter_values($component['value'], NULL, NULL, NULL, FALSE) : $component['value'],
    '#weight' => $component['weight'],
    '#description' => $filter ? _webform_filter_descriptions($component['extra']['description']) : $component['extra']['description'],
    '#attributes' => $component['extra']['attributes'],
    '#theme_wrappers' => array('webform_element'),
    '#webform_component' => $component,
  );
  if (isset($value)) {
    $element['#default_value'] = $value[0];
  }
  $element['#attributes']['class'][] = $component['form_key'];
  $element['#attributes']['class'][] = 'webform-sameas-' . $component['form_key'];

  return $element;
}
